#ifndef lint
static char rcsid[] = "$ StrToPmap.c <thoth>, what a hack $";
#endif /* lint */

/*

 I hacked this up from StrToBmap.c.  Since they (MIT X Consortium) did
 most of the work and I only hacked it a little bit, I'm including
 their copyright, HOWEVER, the hacks (specifically the diffs) are
 Copyright 1990 Robert H. Forsman Jr., distributable under the GNU
 General Public License.

 <thoth@cis.ufl.edu>

 */


/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Xmu/Converters.h>
#include	<X11/Xmu/Drawing.h>

/*
 * XmuConvertStringToPixmap:
 *
 * creates a depth-n Pixmap suitable for window manager icons.
 * "string" represents a pixmap(1) filename which may be absolute,
 * or relative to the global resource pixmapFilePath, class
 * PixmapFilePath.  If the resource is not defined, the default
 * value is the build symbol PIXMAPDIR.
 *
 * shares lots of code with XmuConvertStringToCursor.  
 *
 * To use, include the following in your ClassInitialize procedure:

static XtConvertArgRec screenConvertArg[] = {
    {XtBaseOffset, (caddr_t) XtOffset(Widget, core.screen), sizeof(Screen *)}
};

    XtAddConverter("String", "Pixmap", XmuCvtStringToPixmap,
		   screenConvertArg, XtNumber(screenConvertArg));
 *
 */

typedef struct _mbimage {
   Pixmap mask;
   Pixmap pixmap;
   int width, height;
} mbimage;

#define	done(address, type) \
	{ (*toVal).size = sizeof(type); (*toVal).addr = (caddr_t) address; \
	    printf("got it\n");}

/*ARGSUSED*/
void XmuCvtStringToImage(args, num_args, fromVal, toVal)
    XrmValuePtr args;
    Cardinal    *num_args;
    XrmValuePtr	fromVal;
    XrmValuePtr	toVal;
{
    static mbimage image;			/* static for cvt magic */
    char *name = (char *)fromVal->addr;

    printf("converting pixmap...");
    if (*num_args != 2)
     XtErrorMsg("wrongParameters","cvtStringToPixmap","XtToolkitError",
             "String to pixmap conversion needs screen and colormap arguments",
              (String *)NULL, (Cardinal *)NULL);

    if (strcmp(name, "None") == 0) {
	image.pixmap = None;
	done(&image, mbimage);
	return;
    }

    if (strcmp(name, "ParentRelative") == 0) {
	image.pixmap = ParentRelative;
	done(&image, mbimage);
	return;
    }

    image.pixmap = XmuLocateXpmFile (*((Screen **) args[0].addr), 
			*((Colormap *) args[1].addr), name, NULL, 0,
			&image.width, &image.height, &image.mask);

    if (image.pixmap != None) {
	done (&image, mbimage);
    } else {
	image.pixmap = XmuLocateBitmapFile (*((Screen **) args[0].addr),
				name, NULL, 0, &image.width, &image.height, NULL, NULL);
	if (image.pixmap != None) {
	   done (&image, mbimage);
	} else {
	   XtStringConversionWarning (name, "Image");
	   printf("failed\n");
	   done (&image, mbimage);
	}
    }
}

